Bug 197985 - possible circular locking dependency detected ( FC5 + kernel-2.6.17-1.2356.fc6 )
possible circular locking dependency detected ( FC5 + kernel-2.6.17-1.2356....
Status: CLOSED CURRENTRELEASE
Product: Fedora
Classification: Fedora
Component: kernel (Show other bugs)
5
All Linux
medium Severity medium
: ---
: ---
Assigned To: Kernel Maintainer List
Brian Brock
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2006-07-07 16:53 EDT by dan ginsberg
Modified: 2007-12-29 07:04 EST (History)
1 user (show)

See Also:
Fixed In Version: 2.6.18-1.2200.fc5
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2007-12-29 07:04:26 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description dan ginsberg 2006-07-07 16:53:14 EDT
Description of problem:

[ INFO: possible circular locking dependency detected ]
-------------------------------------------------------
ls/2480 is trying to acquire lock:
 (sk_lock-AF_INET){--..}, at: [<c05d9b28>] tcp_sendmsg+0x14/0x9ac

but task is already holding lock:
 (&inode->i_mutex){--..}, at: [<c060d6bb>] mutex_lock+0x21/0x24

which lock already depends on the new lock.


the existing dependency chain (in reverse order) is:

-> #2 (&inode->i_mutex){--..}:
       [<c043c546>] lock_acquire+0x4b/0x6d
       [<c060d51e>] __mutex_lock_slowpath+0xbf/0x23b
       [<c060d6bb>] mutex_lock+0x21/0x24
       [<c04ac0ae>] create_dir+0x20/0x191
       [<c04ac745>] sysfs_create_dir+0x48/0x63
       [<c04e40fe>] kobject_add+0xf0/0x19a
       [<c0550ccf>] class_device_add+0x99/0x3e6
       [<c05bfb50>] netdev_register_sysfs+0x76/0x7b
       [<c05b5b27>] register_netdevice+0x23a/0x2fd
       [<c05b6bec>] register_netdev+0x5c/0x69
       [<c07c385e>] loopback_init+0x3e/0x41
       [<c07c3792>] net_olddevs_init+0xa/0x98
       [<c04003f0>] init+0x11c/0x29a
       [<c0402005>] kernel_thread_helper+0x5/0xb

-> #1 (rtnl_mutex){--..}:
       [<c043c546>] lock_acquire+0x4b/0x6d
       [<c060d51e>] __mutex_lock_slowpath+0xbf/0x23b
       [<c060d6bb>] mutex_lock+0x21/0x24
       [<c05bd80a>] rtnl_lock+0xd/0xf
       [<c05f43a4>] ip_mc_join_group+0x2c/0xc9
       [<c05d5f92>] ip_setsockopt+0x66b/0x9be
       [<c05ea4eb>] raw_setsockopt+0x21/0x63
       [<c05aea06>] sock_common_setsockopt+0x13/0x18
       [<c05ad6c7>] sys_setsockopt+0x6f/0x8d
       [<c05ae644>] sys_socketcall+0x148/0x186
       [<c0403f2f>] syscall_call+0x7/0xb

-> #0 (sk_lock-AF_INET){--..}:
       [<c043c546>] lock_acquire+0x4b/0x6d
       [<c05af0c8>] lock_sock+0xac/0xbc
       [<c05d9b28>] tcp_sendmsg+0x14/0x9ac
       [<c05f17dd>] inet_sendmsg+0x3b/0x48
       [<c05accaf>] sock_sendmsg+0xe8/0x103
       [<c05ae6aa>] kernel_sendmsg+0x28/0x37
       [<e0bd0320>] smb_send+0x80/0xfd [cifs]
       [<e0bd0771>] SendReceive+0x2a7/0x684 [cifs]
       [<e0bc042d>] CIFSFindFirst+0x224/0x30d [cifs]
       [<e0bd474c>] initiate_cifs_search+0x131/0x175 [cifs]
       [<e0bd4cfa>] cifs_readdir+0x197/0xf4d [cifs]
       [<c0482a04>] vfs_readdir+0x67/0x93
       [<c0482a8e>] sys_getdents64+0x5e/0xa0
       [<c0403f2f>] syscall_call+0x7/0xb

other info that might help us debug this:

1 lock held by ls/2480:
 #0:  (&inode->i_mutex){--..}, at: [<c060d6bb>] mutex_lock+0x21/0x24

stack backtrace:
 [<c0405167>] show_trace_log_lvl+0x54/0xfd
 [<c040571e>] show_trace+0xd/0x10
 [<c040583d>] dump_stack+0x19/0x1b
 [<c043b63d>] print_circular_bug_tail+0x59/0x64
 [<c043be35>] __lock_acquire+0x7ed/0x98d
 [<c043c546>] lock_acquire+0x4b/0x6d
 [<c05af0c8>] lock_sock+0xac/0xbc
 [<c05d9b28>] tcp_sendmsg+0x14/0x9ac
 [<c05f17dd>] inet_sendmsg+0x3b/0x48
 [<c05accaf>] sock_sendmsg+0xe8/0x103
 [<c05ae6aa>] kernel_sendmsg+0x28/0x37
 [<e0bd0320>] smb_send+0x80/0xfd [cifs]
 [<e0bd0771>] SendReceive+0x2a7/0x684 [cifs]
 [<e0bc042d>] CIFSFindFirst+0x224/0x30d [cifs]
 [<e0bd474c>] initiate_cifs_search+0x131/0x175 [cifs]
 [<e0bd4cfa>] cifs_readdir+0x197/0xf4d [cifs]
 [<c0482a04>] vfs_readdir+0x67/0x93
 [<c0482a8e>] sys_getdents64+0x5e/0xa0
 [<c0403f2f>] syscall_call+0x7/0xb


Not sure when this fired, but I've browsed a few automounted cifs shares.
Comment 1 dan ginsberg 2006-07-07 17:02:50 EDT
hrm... looks like this is the same on that dave jones posted to lkml only via
cifs rather than nfs (
http://www.ussg.iu.edu/hypermail/linux/kernel/0607.0/2020.html )
Comment 2 Dave Jones 2006-10-16 13:41:22 EDT
A new kernel update has been released (Version: 2.6.18-1.2200.fc5)
based upon a new upstream kernel release.

Please retest against this new kernel, as a large number of patches
go into each upstream release, possibly including changes that
may address this problem.

This bug has been placed in NEEDINFO state.
Due to the large volume of inactive bugs in bugzilla, if this bug is
still in this state in two weeks time, it will be closed.

Should this bug still be relevant after this period, the reporter
can reopen the bug at any time. Any other users on the Cc: list
of this bug can request that the bug be reopened by adding a
comment to the bug.

In the last few updates, some users upgrading from FC4->FC5
have reported that installing a kernel update has left their
systems unbootable. If you have been affected by this problem
please check you only have one version of device-mapper & lvm2
installed.  See bug 207474 for further details.

If this bug is a problem preventing you from installing the
release this version is filed against, please see bug 169613.

If this bug has been fixed, but you are now experiencing a different
problem, please file a separate bug for the new problem.

Thank you.
Comment 3 dan ginsberg 2006-10-16 13:58:15 EDT
This can be closed.  This was one of the first lockdep bugs fixed once lockdep
was merged.
Comment 4 Jeff Layton 2007-12-29 07:04:26 EST
Closing per last comment...

Note You need to log in before you can comment on or make changes to this bug.